export default class Select {

    template = `
        <label class="label is-small" id="label"></label>
        <div class="control">
            <div class="select is-small is-fullwidth">
                <select id="list"></select>
            </div>
        </div>`

    addList(data, selectedValue = null) {
        this.list = data;
        this.value = selectedValue;
        this.listView.innerHTML = `<option value=""></option>`;
        for(let item of this.list) {
            if (this.value == item.id) {
                this.listView.innerHTML += `<option value="${item.id}" selected>${item.value}</option>`;
            } else {
                this.listView.innerHTML += `<option value="${item.id}">${item.value}</option>`;
            }            
        }
    }

    render() {
        this.view = document.createElement('div');
        this.view.classList.add('field');
        this.view.innerHTML = this.template;
        this.labelView = this.view.querySelector('#label');
        this.labelView.innerHTML = this.label;
        this.listView = this.view.querySelector('#list');
        this.listView.addEventListener('change', () => {
            this.value = this.listView.value;
            this.handler(this.value, this.parent);
        });
    }

    constructor(data, parent) {
        this.parent = parent;
        this.label = data.label;
        this.field = data.field;
        this.handler = data.handler;
        this.render();
    }
}