export default class SelectCompany {

    template = `
        <label class="label is-small" id="label"></label>
        <div class="field has-addons">
            <button class="button is-small mr-4" id="button-search">Выбрать</button>
            <div id="value-view"></div>
        </div>`

    setValue(data) {
        this.value = data.id;
        this.title = data.title;
        this.valueView.innerText = this.title;
    }

    render() {
        this.view = document.createElement('div');
        this.view.classList.add('field');
        this.view.innerHTML = this.template;
        this.labelView = this.view.querySelector('#label');
        this.labelView.innerHTML = this.label;
        this.valueView = this.view.querySelector('#value-view');
        this.buttonSearch = this.view.querySelector('#button-search');
        this.buttonSearch.addEventListener('click', () => {
            BX24.selectCRM({
                entityType: ['company'],
            }, function() {
                let companyData = arguments[0]['company'][0];
                console.log(companyData);
                this.valueView.innerText = companyData.title
                this.value = companyData.id.replace('CO_','');
                this.handler(this.value, this.parent);
            }.bind(this));
            
        });
    }

    constructor(data, parent) {
        this.parent = parent;
        this.label = data.label;
        this.field = data.field;
        this.handler = data.handler;
        this.render();
    }
}